package com.example.resiliance;

import com.netflix.hystrix.HystrixCommand;
import com.netflix.hystrix.HystrixCommandGroupKey;
import com.netflix.hystrix.HystrixCommandKey;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/cat")
public class FactController {

    @GetMapping
    @RequestMapping("/fact")
    public String getFact() {
        HystrixCommand.Setter config = HystrixCommand
                .Setter
                .withGroupKey(HystrixCommandGroupKey.Factory.asKey("catfact"))
                .andCommandKey(HystrixCommandKey.Factory.asKey("catfactcmd"));

        String fact = new RemoteServiceCatCommand(config, new CatApi()).execute();
        if(fact == null){
            return "no success";
        }
        return fact;
    }

}
