package com.example.resiliance;

import com.netflix.hystrix.HystrixCommand;
import org.springframework.web.client.RestTemplate;

class RemoteServiceCatCommand extends HystrixCommand<String> {

    CatApi remoteService;

    RemoteServiceCatCommand(Setter config, CatApi remoteService) {
        super(config);
        this.remoteService = remoteService;
    }

    @Override
    protected String run() throws Exception {
        RestTemplate restTemplate = new RestTemplate();
        CatFact fact = restTemplate.getForEntity("https://catfact.ninja/fact", CatFact.class).getBody();
        if (fact == null){
            return "";
        }
        return fact.getFact();
    }
}
